
        .XCREF
        .NOLIST
        INCLUDE    \masm32\include\masm32rt.inc
        .LIST

;###############################################################################################

StrLength PROTO    :LPSTR
ConOut    PROTO    :LPSTR

;###############################################################################################

        .DATA

Buff1   db 255 dup('X'),0
Buff2   db 255 dup('X'),0
szEnter db 'Enter a String: ',0
szCrLf  db 13,10,0

;***********************************************************************************************

hStdInp      HANDLE ?
hStdOut      HANDLE ?

;###############################################################################################

        .CODE

;***********************************************************************************************

_main   PROC

        call    StdInit

        INVOKE  ConOut,offset szEnter
        call    ConIn1
        INVOKE  ConOut,offset Buff1
        INVOKE  ConOut,offset szCrLf

        INVOKE  ConOut,offset szEnter
        call    ConIn2
        INVOKE  ConOut,offset Buff2
        INVOKE  ConOut,offset szCrLf

        inkey
        exit

_main   ENDP

;***********************************************************************************************

StdInit PROC

        INVOKE  GetStdHandle,STD_OUTPUT_HANDLE
        mov     hStdOut,eax
        INVOKE  GetStdHandle,STD_INPUT_HANDLE
        mov     hStdInp,eax
        INVOKE  SetConsoleMode,eax,ENABLE_LINE_INPUT or ENABLE_ECHO_INPUT or ENABLE_PROCESSED_INPUT
        ret

StdInit ENDP

;***********************************************************************************************

ConIn1  PROC

        xor     eax,eax
        push    eax
        mov     edx,esp
        INVOKE  ReadFile,hStdInp,offset Buff1,sizeof Buff1,edx,eax
        pop     eax
        ret

ConIn1  ENDP

;***********************************************************************************************

ConIn2  PROC

        xor     eax,eax
        push    eax
        mov     edx,esp
        INVOKE  ReadConsole,hStdInp,offset Buff2,sizeof Buff2,edx,eax
        pop     eax
        ret

ConIn2  ENDP

;***********************************************************************************************

StrLength PROC  USES EDI lpString:LPSTR

        mov     edi,lpString
        xor     eax,eax
        or      ecx,-1
        repnz   scasb
        or      eax,-2
        sub     eax,ecx
        ret

StrLength ENDP

;***********************************************************************************************

ConOut  PROC    USES ESI lpString:LPSTR

        mov     esi,lpString
        INVOKE  StrLength,esi
        xor     ecx,ecx
        push    ecx
        mov     edx,esp
        INVOKE  WriteFile,hStdOut,esi,eax,edx,ecx
        pop     eax
        ret

ConOut  ENDP

;###############################################################################################

        END     _main

